<?php

/**
 * admin_masiva_super_apoyo actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage admin_masiva_super_apoyo
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class admin_masiva_super_apoyoActions extends sfActions {

    /**
     * Executes de actualizacion masiva super y apoyo
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' Order by ';
        }


        $this->conn = Doctrine_Manager::getInstance()->getCurrentConnection();
        $this->conn->beginTransaction();


        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $fecha = $request['fecha'];
            $tipo_actual = $request['tipo_actual'];
            $usuario_log = $request['username'];

            /*
             * Variables opcionales
             */
            //numero_doc
            if (isset($request['numero_doc'])) {
                $numero_doc = $request['numero_doc'];
            } else {
                $numero_doc = '';
            }
            //fecha_doc
            if (isset($request['fecha_doc'])) {
                $fecha_doc = $request['fecha_doc'];
            } else {
                $fecha_doc = '';
            }
            //observaciones
            if (isset($request['observaciones'])) {
                $observaciones = $request['observaciones'];
            } else {
                $observaciones = '';
            }
            if (isset($request['adjunto'])) {
                $adjunto = "'" . $request['adjunto'] . "'";
            } else {
                $adjunto = 'null';
            }


            //id_supervisor_old
            if (isset($request['id_supervisor_old'])) {
                $id_supervisor_old = $request['id_supervisor_old'];
            } else {
                $id_supervisor_old = '';
            }
            //id_supervisor_new
            if (isset($request['id_supervisor_new'])) {
                $id_supervisor_new = $request['id_supervisor_new'];
            } else {
                $id_supervisor_new = '';
            }
            //id_apoyo_supervisor_old
            if (isset($request['id_apoyo_supervisor_old'])) {
                $id_apoyo_supervisor_old = $request['id_apoyo_supervisor_old'];
            } else {
                $id_apoyo_supervisor_old = '';
            }
            //id_apoyo_supervisor_new
            if (isset($request['id_apoyo_supervisor_new'])) {
                $id_apoyo_supervisor_new = $request['id_apoyo_supervisor_new'];
            } else {
                $id_apoyo_supervisor_new = '';
            }

            //Incidente #30129, fechas de nov sup - 20230106::LAVILA
            if (isset($request['fecha_ini_supr'])) {
                $fecha_ini_supr = $request['fecha_ini_supr'];
            } else {
                $fecha_ini_supr = '';
            }
            if (isset($request['fecha_fin_supr'])) {
                $fecha_fin_supr = $request['fecha_fin_supr'];
            } else {
                $fecha_fin_supr = '';
            }

            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            $resultado = array();

            /**
             * Actualizasion masiva - 20180905
             */
            $this->logMessage("Tipo_actual: " . $tipo_actual);
            if ($tipo_actual == 'Actualizar Supervisor') {

                //Crear novedad de supervisor/apoyo
                $sql = <<<EOD
insert into RVC_NOVEDAD_SUPR_APOY (
ID_NOVEDAD_SUPR_APOY,
ID_CONTRATO,
FECHA,
NUMERO_DOC,
FECHA_DOC,
OBSERVACIONES,
ID_SUPERVISOR_OLD,
ID_APOYO_SUPERVISOR_OLD,
ID_SUPERVISOR_NEW,
ID_APOYO_SUPERVISOR_NEW,
USUARIO_LOG,
FECHA_LOG,
ADJUNTO,
FECHA_INI_SUPR,
FECHA_FIN_SUPR
)
                        
select
null as id_novedad_supr_apoy,
cont.id_contrato as id_contrato,
to_date('$fecha','yyyy-mm-dd') as fecha,
'$numero_doc' as numero_doc,
to_date('$fecha_doc','yyyy-mm-dd') as fecha_doc,
'$observaciones' as observaciones,
cont.id_supervisor as id_supervisor_old,
cont.id_apoyo_supervisor as id_apoyo_supervisor_old,
'$id_supervisor_new' as id_supervisor_new,
cont.id_apoyo_supervisor as id_apoyo_supervisor_new,
'$usuario_log' as usuario_log,
sysdate as fecha_log,
$adjunto as adjunto,
to_date('$fecha_ini_supr','yyyy-mm-dd') as fecha_ini_supr,
to_date('$fecha_fin_supr','yyyy-mm-dd') as fecha_fin_supr     

from rvc_contrato cont

left join RVC_NOVEDAD_SUPR_APOY_V nov
on nov.id_contrato = cont.id_contrato
and nov.rn = 1

where
cont.estado = 1
and cont.fecha_fin >= TRUNC(SYSDATE)
and cont.id_supervisor = '$id_supervisor_old'                 
EOD;
                $this->conn->execute($sql);

                //Actualizar contratos activos y con fecha_fin contrato es igual o mayor a la actual
                //20190514 se comenta la condicion d efecha fin po solicitud del usuario
                $sql = <<<EOD
update rvc_contrato 
set id_supervisor = '$id_supervisor_new'
where
id_contrato in (
    SELECT
    id_contrato
    FROM rvc_contrato
    where
    estado = 1
    --and fecha_fin >= TRUNC(SYSDATE)
    and id_supervisor = '$id_supervisor_old' 
)                        
EOD;
                $this->conn->execute($sql);
            } else {

                //Crear novedad de supervisor/apoyo
                $sql = <<<EOD
insert into RVC_NOVEDAD_SUPR_APOY (
ID_NOVEDAD_SUPR_APOY,
ID_CONTRATO,
FECHA,
NUMERO_DOC,
FECHA_DOC,
OBSERVACIONES,
ID_SUPERVISOR_OLD,
ID_APOYO_SUPERVISOR_OLD,
ID_SUPERVISOR_NEW,
ID_APOYO_SUPERVISOR_NEW,
USUARIO_LOG,
FECHA_LOG,
ADJUNTO,
FECHA_INI_SUPR,
FECHA_FIN_SUPR
)
                        
select
null as id_novedad_supr_apoy,
cont.id_contrato as id_contrato,
to_date('$fecha','yyyy-mm-dd') as fecha,
'$numero_doc' as numero_doc,
to_date('$fecha_doc','yyyy-mm-dd') as fecha_doc,
'$observaciones' as observaciones,
cont.id_supervisor as id_supervisor_old,
cont.id_apoyo_supervisor as id_apoyo_supervisor_old,
cont.id_supervisor as id_supervisor_new,
'$id_apoyo_supervisor_new' as id_apoyo_supervisor_new,
'$usuario_log' as usuario_log,
sysdate as fecha_log,
nov.adjunto as adjunto,
nov.fecha_ini_supr as fecha_ini_supr,
nov.fecha_fin_supr as fecha_fin_supr                       

from rvc_contrato cont

left join RVC_NOVEDAD_SUPR_APOY_V nov
on nov.id_contrato = cont.id_contrato
and nov.rn = 1

where
cont.estado = 1
and cont.fecha_fin >= TRUNC(SYSDATE)
and cont.id_apoyo_supervisor = '$id_apoyo_supervisor_old'      
EOD;
                $this->conn->execute($sql);

                //Actualizar contratos activos y con fecha_fin contrato es igual o mayor a la actual
                //20190514 se comenta la condicion d efecha fin po solicitud del usuario
                $sql = <<<EOD
update rvc_contrato 
set id_apoyo_supervisor = '$id_apoyo_supervisor_new'
where
id_contrato in (
    SELECT
    id_contrato
    FROM rvc_contrato
    where
    estado = 1
    --and fecha_fin >= TRUNC(SYSDATE)
    and id_apoyo_supervisor = '$id_apoyo_supervisor_old' 
)                        
EOD;
                $this->conn->execute($sql);
            }

            //COMMIT DE TODAS LAS TRANSACCIONES
            $this->conn->commit();

            $this->status = 0;
            $this->totalRows = count($resultado);
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[admin_masiva_super_apoyo] Consulta exitosa.");
        } catch (Exception $e) {

            //ROLLBACK DE TODAS LAS TRANSACCIONES EN CASO DE QUE OCURRA ALGUN ERROR
            $this->conn->rollback();
            $mensaje = "ROLLBACK DE TODAS LAS TRANSACCIONES";

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->mensajeError = $mensaje;
            $this->logMessage("ERROR!!! admin_masiva_super_apoyo");
            $this->logMessage($e->getMessage());
            $this->logMessage($mensaje);
        }
    }

}
